commit 148cc7e8321811d5103ccef22a7af5b020f60c01
parent 46f91c5f712c96331315d420430105c960418460
Author: Luke Smith <luke@lukesmith.xyz>
Date: Sun, 21 Apr 2019 20:42:39 -0400
no bin
Diffstat:
D | bin/mailcap | | | 7 | ------- |
A | bin/mw | | | 306 | +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ |
A | mailcap | | | 7 | +++++++ |
D | mw | | | 308 | ------------------------------------------------------------------------------- |
4 files changed, 313 insertions(+), 315 deletions(-)
diff --git a/bin/mailcap b/bin/mailcap
@@ -1,7 +0,0 @@
-text/plain; vim %s ;
-text/html; ~/.config/mutt/bin/openfile %s ;
-text/html; w3m -I %{charset} -T text/html; copiousoutput;
-image/*; ~/.config/mutt/bin/muttimage %s ; copiousoutput
-video/*; setsid mpv --quiet %s &; copiousoutput
-application/pdf; ~/.config/mutt/bin/openfile %s ;
-application/pgp-encrypted; gpg -d '%s'; copiousoutput;
diff --git a/bin/mw b/bin/mw
@@ -0,0 +1,306 @@
+#!/bin/sh
+muttdir="$HOME/.config/mutt" # Main mutt config location
+[ ! -f "$HOME/.password-store/.gpg-id" ] && printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`gpg --full-gen-key\` first.\\n" && exit
+accdir="$muttdir/accounts" # Directory for account settings
+maildir="$HOME/.local/share/mail" # Location of mail storage
+namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
+emailre=".\+@.\+\\..\+" # Regex to confirm valid email address
+mbsyncrc="$HOME/.mbsyncrc"
+sslcert="/etc/ssl/certs/ca-certificates.crt"
+
+getprofiles() { \
+ unset msmtp_header msmtp_profile mutt_profile mbsync_profile
+ printf "Creating profiles for \`%s\`..." "$title"
+msmtp_header="defaults
+auth on
+tls on
+tls_trust_file $sslcert
+logfile ~/.config/msmtp/msmtp.log
+"
+msmtp_profile="
+account $title
+host $smtp
+port $sport
+from $fulladdr
+user $login
+passwordeval \"pass mutt-wizard-$title\""
+mbsync_profile="IMAPStore $title-remote
+Host $imap
+Port $iport
+User $login
+PassCmd \"pass mutt-wizard-$title\"
+SSLType IMAPS
+CertificateFile /etc/ssl/certs/ca-certificates.crt
+
+MaildirStore $title-local
+Subfolders Verbatim
+Path ~/.local/share/mail/$title/
+Inbox ~/.local/share/mail/$title/INBOX
+Flatten .
+
+Channel $title
+Expunge Both
+Master :$title-remote:
+Slave :$title-local:
+Patterns * !\"[Gmail]/All Mail\"
+Create Both
+SyncState *
+# End profile
+"
+
+if [ "$accounttype" = "offline" ]; then
+mutt_profile="# vim: filetype=neomuttrc
+# muttrc file for account $title
+set realname = \"$realname\"
+set from = \"$fulladdr\"
+set sendmail = \"/usr/bin/msmtp -a $title\"
+alias me $realname <$fulladdr>
+set folder = \"$maildir/$title\"
+set header_cache = $accdir/$title/cache/headers
+set message_cachedir = $accdir/$title/cache/bodies
+set certificate_file = $accdir/$title/certificates
+set mbox_type = Maildir
+
+bind index,pager gg noop
+bind index,pager g noop
+bind index,pager M noop
+bind index,pager C noop
+bind index gg first-entry
+macro index o \"<shell-escape>$HOME/.config/mutt/bin/mailsync -V $title<enter>\" \"run mbsync to sync $title\"
+unmailboxes *
+"
+else
+mutt_profile="# vim: filetype=neomuttrc
+# muttrc file for account $title
+set realname = \"$realname\"
+set from = \"$fulladdr\"
+set sendmail = \"/usr/bin/msmtp -a $title\"
+alias me $realname <$fulladdr>
+set folder = \"imaps://$fulladdr@$imap:$iport\"
+set imap_user = \"$login\"
+set header_cache = $accdir/$title/cache/headers
+set message_cachedir = $accdir/$title/cache/bodies
+set certificate_file = $accdir/$title/certificates
+set imap_pass = \`pass mutt-wizard-$title\`
+
+set mbox_type = Maildir
+set ssl_starttls = yes
+set ssl_force_tls = yes
+
+bind index,pager gg noop
+bind index,pager g noop
+bind index,pager M noop
+bind index,pager C noop
+bind index gg first-entry
+unmailboxes *
+"
+fi
+ printf "DONE.\\n"
+}
+
+addaccount() { \
+ printf "Insert the \033[31memail address\033[0m that you want to autoconfigure for mutt/mbsync\\n\tEmail: \033[36m"
+ read -r fulladdr
+ printf "\033[0m"
+ while ! echo "$fulladdr" | grep "$emailre" >/dev/null; do
+ printf "That is not a valid \033[31memail address\033[0m, please retype the desired email.\\n\\nEmail: \033[36m\t"
+ read -r fulladdr
+ printf "\033[0m"
+ done
+ domain="$(echo "$fulladdr" | sed "s/.*@//")"
+ printf "\\nSearching for \033[32m%s\033[0m in \033[34m\`domains.csv\`\033[0m..." "$domain"
+ serverinfo="$(grep "$domain" "$muttdir/domains.csv" 2>/dev/null)"
+ if [ -z "$serverinfo" ]; then
+ printf "Your email domain is not in mutt-wizard's database yet.\\nmutt-wizard will still autoconfigure everything, but you will have to manually type in your service's IMAP and SMTP server information.\\nYou can usually quickly find this by internet searching for it.\\n"
+ printf "Insert the IMAP server for your email provider (excluding the port number)\\n\033[36m\t"
+ read -r imap
+ printf "\033[0mWhat is your server's IMAP port number? (Usually something like 993)\\n\033[36m\t"
+ read -r iport
+ printf "\033[0mInsert the SMTP server for your email provider (excluding the port number)\\n\033[36m\t"
+ read -r smtp
+ printf "\033[0mWhat is your server's SMTP port number? (Usually 587 or 465)\\n\033[36m\t"
+ read -r sport
+ printf "\033[0m\\nGreat! If you want to be helpful, copy the line below and you can add it to the \`domains.csv\` file on Github.\\nThis will make things easier for others who use your email provider.\\n\\n%s,%s,%s,%s,%s\\n\\nAlthough be sure to test to see if these settings work first! ;-)\\n" "$domain" "$imap" "$iport" "$smtp" "$sport"
+ else
+ IFS=, read -r service imap iport smtp sport <<EOF
+$serverinfo
+EOF
+ printf "\\n\033[3;33mCongrats!\033[0m Server info has automatically be found, so you won't have to look anything up!\\n\t\033[1mIMAP server\033[0m: %s\\n\t\033[1mIMAP port\033[0m: %s\\n\t\033[1mSMTP server\033[0m: %s\\n\t\033[1mSMTP port\033[0m: %s\\nThis data will be used by the wizard.\\n" "$imap" "$iport" "$smtp" "$sport"
+ case "$service" in
+ gmail.com) printf "\033[31mREMEMBER: Gmail users must enable \"less secure\" (third-party) applications first for the sync to work:\\nhttps://support.google.com/accounts/answer/6010255\\n\033[0m" ;;
+ protonmail.*) printf "\033[31mREMEMBER: Protonmail users must install and configure Protonmail Bridge first for the sync to work:\\nhttps://protonmail.com/bridge/\\n\033[0m" ;;
+ esac
+ fi
+ printf "Enter the \033[35mfull name\033[0m you want to be identified by on this account.\\n\tReal name: "
+ read -r realname
+ printf "Enter a short, \033[36mone-word identifier\033[0m for this email account that will distinguish them from any other accounts you add.\\n\tAccount name: "
+ read -r title
+ while ! echo "$title" | grep "$namere" >/dev/null; do
+ printf "\033[31mTry again\033[0m. Pick a nickname that is one word only including lowercase letters and _ or -.\\n\tAccount name: \033[36m\t"
+ read -r title
+ printf "\033[0m"
+ done
+ printf "If your account has a special username different from your address, insert it now. Otherwise leave this prompt totally blank.\\n\033[34mMost accounts will not have a separate login, so you should probably leave this blank.\033[0m\\n\tLogin(?): \033[36m"
+ read -r login
+ printf "\033[0m"
+ [ -z "$login" ] && login="$fulladdr"
+ tmpdir="$(mktemp -d)"
+ grep "i[0-9]" "$muttdir/personal.muttrc" 2>/dev/null | awk '{print $3}' | sed -e 's/i//g' > "$tmpdir/mutt_used"
+ seq 1 9 > "$tmpdir/mutt_all"
+ idnum=$(diff "$tmpdir/mutt_all" "$tmpdir/mutt_used" | sed -n 2p | awk '{print $2}')
+ getpass
+ getprofiles
+ mkdir -p "$accdir/$title/cache/bodies" "$HOME/.config/msmtp"
+ [ ! -f "$HOME/.config/msmtp/config" ] && echo "$msmtp_header" > "$HOME/.config/msmtp/config"
+ echo "$msmtp_profile" >> "$HOME/.config/msmtp/config"
+ echo "$mutt_profile" > "$accdir/$title.muttrc"
+ echo "$mbsync_profile" >> "$mbsyncrc"
+ echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$title.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\"" >> "$muttdir/personal.muttrc"
+ ! grep "^source.*.muttrc" "$muttdir/personal.muttrc" >/dev/null && echo "source $accdir/$title.muttrc" >> "$muttdir/personal.muttrc"
+ trysync && finalize
+}
+
+getpass() { while : ; do pass rm -f "mutt-wizard-$title" >/dev/null 2>&1
+ pass insert "mutt-wizard-$title" && break; done ;}
+
+formatShortcut() { \
+ while read -r data; do { echo "macro index,pager g$1 \"<change-folder>$data<enter>\" \"go to $2\" # autogenerated"
+ echo "macro index,pager M$1 \"<save-message>$data<enter>\" \"move mail to $2\" # autogenerated"
+ echo "macro index,pager C$1 \"<copy-message>$data<enter>\" \"copy mail to $2\" # autogenerated"; } >> "$accdir/$3.muttrc"
+ done ;}
+
+trysync() { ! ping -q -c 1 1.1.1.1 > /dev/null && printf "No internet connection detected.\\nTry rerunning \`mbsync %s\` manually when connection is established, then select the option to detect mailboxes and finalize installation.\\n" "$title" && return 1
+ mkdir -p "$maildir/$title"
+ if mailboxes="$(mbsync -l "$title" | sed 's/\//./')" >/dev/null 2>&1; then
+ [ "$accounttype" = "online" ] && sed -i "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc"
+ printf "\033[32mMailboxes detected.\033[0m\\n"
+ echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$title/{}"
+ else
+ printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or sever settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
+ delete "$title"; return 1
+ fi
+}
+
+finalize() { \
+ boxes="$(du -a "$maildir/$title/"* -d 0 | sed "s/^.*\//=/")"
+ [ -z "$boxes" ] && printf "\033[31mNo local mailboxes have been detected for %s.\033[0m\\nThis means that mbsync has not been successfully run.\\nRun mbsync, and if it has an error, be sure to check your password and server settings manually if needbe.\\n" "$title" && return
+ echo "$boxes" > "$tmpdir/title_boxes"
+ printf "Setting up the mutt sidebar...\\n"
+ sidebar_width="$(sed -n -e '/^set sidebar_width/p' "$muttdir/muttrc" | awk -F'=' '{print $2}')"
+ delim="$(head -c "$sidebar_width" < /dev/zero | tr '\0' =)"
+ printf "Setting default mailboxes for your Inbox, Sent, Drafts and Trash in mutt...\\n"
+ oneline="$(sed -e "s/^\|$/\"/g" "$tmpdir/title_boxes" | tr "\n" " ")"
+ oneline="=$title $delim $oneline"
+ spoolfile=$(grep -i -m 1 "$tmpdir/title_boxes" -e inbox | sed -e 's/=/+/g')
+ record=$(grep -i -m 1 "$tmpdir/title_boxes" -e sent | sed -e 's/=/+/g')
+ postponed=$(grep -i -m 1 "$tmpdir/title_boxes" -e draft | sed -e 's/=/+/g')
+ trash=$(grep -i -m 1 "$tmpdir/title_boxes" -e trash | sed -e 's/=/+/g')
+ sed -i "/^mailboxes\|^set record\|^set postponed\|^set trash\|^set spoolfile/d" "$accdir/$title.muttrc"
+ { echo "set spoolfile = \"$spoolfile\""; echo "set record = \"$record\""; echo "set postponed = \"$postponed\""; echo "set trash = \"$trash\""; } >> "$accdir/$title.muttrc"
+ echo mailboxes "$oneline" >> "$accdir/$title.muttrc"
+ printf "Setting up your keyboard shortcuts for jumping between mailboxes...\\n"
+ sed -i "/# autogenerated/d" "$accdir/$title.muttrc"
+ grep -i -m 1 inbox "$tmpdir/title_boxes" | formatShortcut i inbox "$title"
+ grep -i -m 1 sent "$tmpdir/title_boxes" | formatShortcut s sent "$title"
+ grep -i -m 1 draft "$tmpdir/title_boxes" | formatShortcut d drafts "$title"
+ grep -i -m 1 trash "$tmpdir/title_boxes" | formatShortcut t trash "$title"
+ grep -i -m 1 spam "$tmpdir/title_boxes" | formatShortcut S spam "$title"
+ grep -i -m 1 junk "$tmpdir/title_boxes" | formatShortcut j junk "$title"
+ grep -i -m 1 archive "$tmpdir/title_boxes" | formatShortcut a archive "$title"
+ [ "$accounttype" = "offline" ] && printf "All done.\\n\033[33mYou should now be able to run \`\033[32mmbsync %s\033[33m\` to begin to download your mail.\033[0m\\n" "$title"
+}
+
+confirm() { printf "Do you want to to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^y$\|^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
+ printf "Are you really, really sure you want to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^y$\|^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
+ return 0 ;}
+
+pick() { numbered="$(find "$accdir" -mindepth 1 -maxdepth 1 -type d -printf "%f\n" | nl)"
+ [ "$(echo "$numbered" | wc -w)" = 0 ] && printf "No accounts to choose from.\\n" && return 1
+ printf "Select an accounts to %s:\\n" "$1"
+ echo "$numbered"
+ printf "\033[36m\t"
+ read -r input
+ printf "\033[0m"
+ [ -z "$input" ] && return 1
+ title="$(echo "$numbered" | grep "$input" | awk '{print $2}')"
+ [ -z "$title" ] && printf "Invalid response." && return 1
+ return 0 ;}
+
+delete() { sed -i "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc"
+ rm -rf "${accdir:?}/${title:?}" "$accdir/$title.muttrc"
+ sed -i "/$title.muttrc/d" "$muttdir/personal.muttrc"
+ sed -i "/account $title/,/^\(\s*$\|account\)/d" "$HOME/.config/msmtp/config"
+ }
+
+choosecron() { ! pgrep crond >/dev/null && echo "No cron manager running. Install/enable one and then select this option again." && return 1
+ if crontab -l | grep mailsync >/dev/null; then
+ echo "Active mail sync cronjob detected. Do you want to remove it?"
+ printf "\033[36m\t"
+ read -r rmyn
+ printf "\033[0m"
+ echo "$rmyn" | grep -i "^y\(es\)*$" >/dev/null && crontab -l | sed '/mailsync/d' | crontab - >/dev/null && echo "Mail sync turned off."
+ else
+ echo "How many minutes between each mail sync?"
+ printf "\033[36m\t"
+ read -r minnum
+ printf "\033[0m"
+ while ! echo "$minnum" | grep "^[0-9]\+$" >/dev/null; do
+ printf "That doesn't look like a number. How many minutes between each mail sync?\\n\033[36m\t"
+ read -r minnum
+ printf "\033[0m"
+ done
+ (crontab -l; echo "*/$minnum * * * * export DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/1000/bus; export DISPLAY=:0; . \$HOME/.profile; $muttdir/bin/mailsync") | crontab - &&
+ echo "Cronjob added. Mail will sync every $minnum minutes. Be sure you have your cron manager running."
+ fi ;}
+
+addtype() { ! command -v mbsync >/dev/null && printf "You must have the \`mbsync\` command to add an account.\\nIt syncs mail and detects remote mailboxes.\\nYou can typically get it by installing \`isync\`.\\n" && return 1
+ while : ; do
+ printf "Do you want to keep your mail for this account offline with mbsync? [yes/no]\\n\t"
+ read -r offnot
+ case "$offnot" in
+ [Yy][Ee][Ss]) accounttype="offline" && break ;;
+ [Nn][Oo]) accounttype="online" && break ;;
+ *) echo "Write out either yes or no completely. Try again or press ctrl-c to quit." ;;
+ esac
+ done
+ addaccount ;}
+
+main() { while : ; do
+ printf "Welcome to:\\n\033[34m"
+cat << "EOF"
+ _ __ ___ _ _| |_| |_ __ _(_)______ _ _ __ __| |
+| '_ ` _ \| | | | __| __|___\ \ /\ / / |_ / _` | '__/ _` |
+| | | | | | |_| | |_| ||_____\ V V /| |/ / (_| | | | (_| |
+|_| |_| |_|\__,_|\__|\__| \_/\_/ |_/___\__,_|_| \__,_|
+EOF
+
+ printf "\033[0mMade and maintained by Luke Smith <https://lukesmith.xyz>
+
+What would you like \033[32mmutt-wizard\033[0m to do?
+ 1 Add an email account
+ 2 Change an account's password
+ 3 Remove an account
+ 4 Purge all account data
+ 5 Enable/disable autosync
+ 0 Exit
+Input a number to continue or press ctrl-c.\\n"
+ printf "\033[36m\t"
+ read -r choice
+ printf "\033[0m"
+ case "$choice" in
+ 1) addtype ;;
+ 2) pick "change the password of" && confirm "change \`$title\`'s password" && getpass ;;
+ 3) pick delete && confirm "delete the \`$title\` profile" && delete ;;
+ 4) confirm "delete all account data" && rm -rf "$mbsyncrc" "$accdir" "$muttdir/personal.muttrc" && echo "All configs and account settings have been purged." ;;
+ 5) choosecron ;;
+ 0) break ;;
+ *) printf "Invalid input.\\n"
+ esac
+ printf "Press Enter to continue.\\n"
+ stty -echo
+ read -r null
+ stty echo
+done ;}
+
+main
+rm -rf "$tmpdir"
diff --git a/mailcap b/mailcap
@@ -0,0 +1,7 @@
+text/plain; vim %s ;
+text/html; openfile %s ;
+text/html; w3m -I %{charset} -T text/html; copiousoutput;
+image/*; muttimage %s ; copiousoutput
+video/*; setsid mpv --quiet %s &; copiousoutput
+application/pdf; openfile %s ;
+application/pgp-encrypted; gpg -d '%s'; copiousoutput;
diff --git a/mw b/mw
@@ -1,308 +0,0 @@
-#!/bin/sh
-muttdir="$HOME/.config/mutt" # Main mutt config location
-bindir="$HOME/.config/mutt/bin" # Location of scripts run by mutt or the wizard
-[ ! -f "$muttdir/domains.csv" ] || [ ! -d "$bindir" ] && printf "Read the README. Be sure to put the repo in the right place before running.\\n" && exit 1
-[ ! -f "$HOME/.password-store/.gpg-id" ] && printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`gpg --full-gen-key\` first.\\n" && exit
-accdir="$muttdir/accounts" # Directory for account settings
-maildir="$HOME/.local/share/mail" # Location of mail storage
-namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
-emailre=".\+@.\+\\..\+" # Regex to confirm valid email address
-mbsyncrc="$HOME/.mbsyncrc"
-sslcert="/etc/ssl/certs/ca-certificates.crt"
-
-getprofiles() { \
- unset msmtp_header msmtp_profile mutt_profile mbsync_profile
- printf "Creating profiles for \`%s\`..." "$title"
-msmtp_header="defaults
-auth on
-tls on
-tls_trust_file $sslcert
-logfile ~/.config/msmtp/msmtp.log
-"
-msmtp_profile="
-account $title
-host $smtp
-port $sport
-from $fulladdr
-user $login
-passwordeval \"pass mutt-wizard-$title\""
-mbsync_profile="IMAPStore $title-remote
-Host $imap
-Port $iport
-User $login
-PassCmd \"pass mutt-wizard-$title\"
-SSLType IMAPS
-CertificateFile /etc/ssl/certs/ca-certificates.crt
-
-MaildirStore $title-local
-Subfolders Verbatim
-Path ~/.local/share/mail/$title/
-Inbox ~/.local/share/mail/$title/INBOX
-Flatten .
-
-Channel $title
-Expunge Both
-Master :$title-remote:
-Slave :$title-local:
-Patterns * !\"[Gmail]/All Mail\"
-Create Both
-SyncState *
-# End profile
-"
-
-if [ "$accounttype" = "offline" ]; then
-mutt_profile="# vim: filetype=neomuttrc
-# muttrc file for account $title
-set realname = \"$realname\"
-set from = \"$fulladdr\"
-set sendmail = \"/usr/bin/msmtp -a $title\"
-alias me $realname <$fulladdr>
-set folder = \"$maildir/$title\"
-set header_cache = $accdir/$title/cache/headers
-set message_cachedir = $accdir/$title/cache/bodies
-set certificate_file = $accdir/$title/certificates
-set mbox_type = Maildir
-
-bind index,pager gg noop
-bind index,pager g noop
-bind index,pager M noop
-bind index,pager C noop
-bind index gg first-entry
-macro index o \"<shell-escape>$HOME/.config/mutt/bin/mailsync -V $title<enter>\" \"run mbsync to sync $title\"
-unmailboxes *
-"
-else
-mutt_profile="# vim: filetype=neomuttrc
-# muttrc file for account $title
-set realname = \"$realname\"
-set from = \"$fulladdr\"
-set sendmail = \"/usr/bin/msmtp -a $title\"
-alias me $realname <$fulladdr>
-set folder = \"imaps://$fulladdr@$imap:$iport\"
-set imap_user = \"$login\"
-set header_cache = $accdir/$title/cache/headers
-set message_cachedir = $accdir/$title/cache/bodies
-set certificate_file = $accdir/$title/certificates
-set imap_pass = \`pass mutt-wizard-$title\`
-
-set mbox_type = Maildir
-set ssl_starttls = yes
-set ssl_force_tls = yes
-
-bind index,pager gg noop
-bind index,pager g noop
-bind index,pager M noop
-bind index,pager C noop
-bind index gg first-entry
-unmailboxes *
-"
-fi
- printf "DONE.\\n"
-}
-
-addaccount() { \
- printf "Insert the \033[31memail address\033[0m that you want to autoconfigure for mutt/mbsync\\n\tEmail: \033[36m"
- read -r fulladdr
- printf "\033[0m"
- while ! echo "$fulladdr" | grep "$emailre" >/dev/null; do
- printf "That is not a valid \033[31memail address\033[0m, please retype the desired email.\\n\\nEmail: \033[36m\t"
- read -r fulladdr
- printf "\033[0m"
- done
- domain="$(echo "$fulladdr" | sed "s/.*@//")"
- printf "\\nSearching for \033[32m%s\033[0m in \033[34m\`domains.csv\`\033[0m..." "$domain"
- serverinfo="$(grep "$domain" "$muttdir/domains.csv" 2>/dev/null)"
- if [ -z "$serverinfo" ]; then
- printf "Your email domain is not in mutt-wizard's database yet.\\nmutt-wizard will still autoconfigure everything, but you will have to manually type in your service's IMAP and SMTP server information.\\nYou can usually quickly find this by internet searching for it.\\n"
- printf "Insert the IMAP server for your email provider (excluding the port number)\\n\033[36m\t"
- read -r imap
- printf "\033[0mWhat is your server's IMAP port number? (Usually something like 993)\\n\033[36m\t"
- read -r iport
- printf "\033[0mInsert the SMTP server for your email provider (excluding the port number)\\n\033[36m\t"
- read -r smtp
- printf "\033[0mWhat is your server's SMTP port number? (Usually 587 or 465)\\n\033[36m\t"
- read -r sport
- printf "\033[0m\\nGreat! If you want to be helpful, copy the line below and you can add it to the \`domains.csv\` file on Github.\\nThis will make things easier for others who use your email provider.\\n\\n%s,%s,%s,%s,%s\\n\\nAlthough be sure to test to see if these settings work first! ;-)\\n" "$domain" "$imap" "$iport" "$smtp" "$sport"
- else
- IFS=, read -r service imap iport smtp sport <<EOF
-$serverinfo
-EOF
- printf "\\n\033[3;33mCongrats!\033[0m Server info has automatically be found, so you won't have to look anything up!\\n\t\033[1mIMAP server\033[0m: %s\\n\t\033[1mIMAP port\033[0m: %s\\n\t\033[1mSMTP server\033[0m: %s\\n\t\033[1mSMTP port\033[0m: %s\\nThis data will be used by the wizard.\\n" "$imap" "$iport" "$smtp" "$sport"
- case "$service" in
- gmail.com) printf "\033[31mREMEMBER: Gmail users must enable \"less secure\" (third-party) applications first for the sync to work:\\nhttps://support.google.com/accounts/answer/6010255\\n\033[0m" ;;
- protonmail.*) printf "\033[31mREMEMBER: Protonmail users must install and configure Protonmail Bridge first for the sync to work:\\nhttps://protonmail.com/bridge/\\n\033[0m" ;;
- esac
- fi
- printf "Enter the \033[35mfull name\033[0m you want to be identified by on this account.\\n\tReal name: "
- read -r realname
- printf "Enter a short, \033[36mone-word identifier\033[0m for this email account that will distinguish them from any other accounts you add.\\n\tAccount name: "
- read -r title
- while ! echo "$title" | grep "$namere" >/dev/null; do
- printf "\033[31mTry again\033[0m. Pick a nickname that is one word only including lowercase letters and _ or -.\\n\tAccount name: \033[36m\t"
- read -r title
- printf "\033[0m"
- done
- printf "If your account has a special username different from your address, insert it now. Otherwise leave this prompt totally blank.\\n\033[34mMost accounts will not have a separate login, so you should probably leave this blank.\033[0m\\n\tLogin(?): \033[36m"
- read -r login
- printf "\033[0m"
- [ -z "$login" ] && login="$fulladdr"
- tmpdir="$(mktemp -d)"
- grep "i[0-9]" "$muttdir/personal.muttrc" 2>/dev/null | awk '{print $3}' | sed -e 's/i//g' > "$tmpdir/mutt_used"
- seq 1 9 > "$tmpdir/mutt_all"
- idnum=$(diff "$tmpdir/mutt_all" "$tmpdir/mutt_used" | sed -n 2p | awk '{print $2}')
- getpass
- getprofiles
- mkdir -p "$accdir/$title/cache/bodies" "$HOME/.config/msmtp"
- [ ! -f "$HOME/.config/msmtp/config" ] && echo "$msmtp_header" > "$HOME/.config/msmtp/config"
- echo "$msmtp_profile" >> "$HOME/.config/msmtp/config"
- echo "$mutt_profile" > "$accdir/$title.muttrc"
- echo "$mbsync_profile" >> "$mbsyncrc"
- echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$title.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\"" >> "$muttdir/personal.muttrc"
- ! grep "^source.*.muttrc" "$muttdir/personal.muttrc" >/dev/null && echo "source $accdir/$title.muttrc" >> "$muttdir/personal.muttrc"
- trysync && finalize
-}
-
-getpass() { while : ; do pass rm -f "mutt-wizard-$title" >/dev/null 2>&1
- pass insert "mutt-wizard-$title" && break; done ;}
-
-formatShortcut() { \
- while read -r data; do { echo "macro index,pager g$1 \"<change-folder>$data<enter>\" \"go to $2\" # autogenerated"
- echo "macro index,pager M$1 \"<save-message>$data<enter>\" \"move mail to $2\" # autogenerated"
- echo "macro index,pager C$1 \"<copy-message>$data<enter>\" \"copy mail to $2\" # autogenerated"; } >> "$accdir/$3.muttrc"
- done ;}
-
-trysync() { ! ping -q -c 1 1.1.1.1 > /dev/null && printf "No internet connection detected.\\nTry rerunning \`mbsync %s\` manually when connection is established, then select the option to detect mailboxes and finalize installation.\\n" "$title" && return 1
- mkdir -p "$maildir/$title"
- if mailboxes="$(mbsync -l "$title" | sed 's/\//./')" >/dev/null 2>&1; then
- [ "$accounttype" = "online" ] && sed -i "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc"
- printf "\033[32mMailboxes detected.\033[0m\\n"
- echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$title/{}"
- else
- printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or sever settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
- delete "$title"; return 1
- fi
-}
-
-finalize() { \
- boxes="$(du -a "$maildir/$title/"* -d 0 | sed "s/^.*\//=/")"
- [ -z "$boxes" ] && printf "\033[31mNo local mailboxes have been detected for %s.\033[0m\\nThis means that mbsync has not been successfully run.\\nRun mbsync, and if it has an error, be sure to check your password and server settings manually if needbe.\\n" "$title" && return
- echo "$boxes" > "$tmpdir/title_boxes"
- printf "Setting up the mutt sidebar...\\n"
- sidebar_width="$(sed -n -e '/^set sidebar_width/p' "$muttdir/muttrc" | awk -F'=' '{print $2}')"
- delim="$(head -c "$sidebar_width" < /dev/zero | tr '\0' =)"
- printf "Setting default mailboxes for your Inbox, Sent, Drafts and Trash in mutt...\\n"
- oneline="$(sed -e "s/^\|$/\"/g" "$tmpdir/title_boxes" | tr "\n" " ")"
- oneline="=$title $delim $oneline"
- spoolfile=$(grep -i -m 1 "$tmpdir/title_boxes" -e inbox | sed -e 's/=/+/g')
- record=$(grep -i -m 1 "$tmpdir/title_boxes" -e sent | sed -e 's/=/+/g')
- postponed=$(grep -i -m 1 "$tmpdir/title_boxes" -e draft | sed -e 's/=/+/g')
- trash=$(grep -i -m 1 "$tmpdir/title_boxes" -e trash | sed -e 's/=/+/g')
- sed -i "/^mailboxes\|^set record\|^set postponed\|^set trash\|^set spoolfile/d" "$accdir/$title.muttrc"
- { echo "set spoolfile = \"$spoolfile\""; echo "set record = \"$record\""; echo "set postponed = \"$postponed\""; echo "set trash = \"$trash\""; } >> "$accdir/$title.muttrc"
- echo mailboxes "$oneline" >> "$accdir/$title.muttrc"
- printf "Setting up your keyboard shortcuts for jumping between mailboxes...\\n"
- sed -i "/# autogenerated/d" "$accdir/$title.muttrc"
- grep -i -m 1 inbox "$tmpdir/title_boxes" | formatShortcut i inbox "$title"
- grep -i -m 1 sent "$tmpdir/title_boxes" | formatShortcut s sent "$title"
- grep -i -m 1 draft "$tmpdir/title_boxes" | formatShortcut d drafts "$title"
- grep -i -m 1 trash "$tmpdir/title_boxes" | formatShortcut t trash "$title"
- grep -i -m 1 spam "$tmpdir/title_boxes" | formatShortcut S spam "$title"
- grep -i -m 1 junk "$tmpdir/title_boxes" | formatShortcut j junk "$title"
- grep -i -m 1 archive "$tmpdir/title_boxes" | formatShortcut a archive "$title"
- [ "$accounttype" = "offline" ] && printf "All done.\\n\033[33mYou should now be able to run \`\033[32mmbsync %s\033[33m\` to begin to download your mail.\033[0m\\n" "$title"
-}
-
-confirm() { printf "Do you want to to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^y$\|^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
- printf "Are you really, really sure you want to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^y$\|^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
- return 0 ;}
-
-pick() { numbered="$(find "$accdir" -mindepth 1 -maxdepth 1 -type d -printf "%f\n" | nl)"
- [ "$(echo "$numbered" | wc -w)" = 0 ] && printf "No accounts to choose from.\\n" && return 1
- printf "Select an accounts to %s:\\n" "$1"
- echo "$numbered"
- printf "\033[36m\t"
- read -r input
- printf "\033[0m"
- [ -z "$input" ] && return 1
- title="$(echo "$numbered" | grep "$input" | awk '{print $2}')"
- [ -z "$title" ] && printf "Invalid response." && return 1
- return 0 ;}
-
-delete() { sed -i "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc"
- rm -rf "${accdir:?}/${title:?}" "$accdir/$title.muttrc"
- sed -i "/$title.muttrc/d" "$muttdir/personal.muttrc"
- sed -i "/account $title/,/^\(\s*$\|account\)/d" "$HOME/.config/msmtp/config"
- }
-
-choosecron() { ! pgrep crond >/dev/null && echo "No cron manager running. Install/enable one and then select this option again." && return 1
- if crontab -l | grep mailsync >/dev/null; then
- echo "Active mail sync cronjob detected. Do you want to remove it?"
- printf "\033[36m\t"
- read -r rmyn
- printf "\033[0m"
- echo "$rmyn" | grep -i "^y\(es\)*$" >/dev/null && crontab -l | sed '/mailsync/d' | crontab - >/dev/null && echo "Mail sync turned off."
- else
- echo "How many minutes between each mail sync?"
- printf "\033[36m\t"
- read -r minnum
- printf "\033[0m"
- while ! echo "$minnum" | grep "^[0-9]\+$" >/dev/null; do
- printf "That doesn't look like a number. How many minutes between each mail sync?\\n\033[36m\t"
- read -r minnum
- printf "\033[0m"
- done
- (crontab -l; echo "*/$minnum * * * * export DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/1000/bus; export DISPLAY=:0; . \$HOME/.profile; $muttdir/bin/mailsync") | crontab - &&
- echo "Cronjob added. Mail will sync every $minnum minutes. Be sure you have your cron manager running."
- fi ;}
-
-addtype() { ! command -v mbsync >/dev/null && printf "You must have the \`mbsync\` command to add an account.\\nIt syncs mail and detects remote mailboxes.\\nYou can typically get it by installing \`isync\`.\\n" && return 1
- while : ; do
- printf "Do you want to keep your mail for this account offline with mbsync? [yes/no]\\n\t"
- read -r offnot
- case "$offnot" in
- [Yy][Ee][Ss]) accounttype="offline" && break ;;
- [Nn][Oo]) accounttype="online" && break ;;
- *) echo "Write out either yes or no completely. Try again or press ctrl-c to quit." ;;
- esac
- done
- addaccount ;}
-
-main() { while : ; do
- printf "Welcome to:\\n\033[34m"
-cat << "EOF"
- _ __ ___ _ _| |_| |_ __ _(_)______ _ _ __ __| |
-| '_ ` _ \| | | | __| __|___\ \ /\ / / |_ / _` | '__/ _` |
-| | | | | | |_| | |_| ||_____\ V V /| |/ / (_| | | | (_| |
-|_| |_| |_|\__,_|\__|\__| \_/\_/ |_/___\__,_|_| \__,_|
-EOF
-
- printf "\033[0mMade and maintained by Luke Smith <https://lukesmith.xyz>
-
-What would you like \033[32mmutt-wizard\033[0m to do?
- 1 Add an email account
- 2 Change an account's password
- 3 Remove an account
- 4 Purge all account data
- 5 Enable/disable autosync
- 0 Exit
-Input a number to continue or press ctrl-c.\\n"
- printf "\033[36m\t"
- read -r choice
- printf "\033[0m"
- case "$choice" in
- 1) addtype ;;
- 2) pick "change the password of" && confirm "change \`$title\`'s password" && getpass ;;
- 3) pick delete && confirm "delete the \`$title\` profile" && delete ;;
- 4) confirm "delete all account data" && rm -rf "$mbsyncrc" "$accdir" "$muttdir/personal.muttrc" && echo "All configs and account settings have been purged." ;;
- 5) choosecron ;;
- 0) break ;;
- *) printf "Invalid input.\\n"
- esac
- printf "Press Enter to continue.\\n"
- stty -echo
- read -r null
- stty echo
-done ;}
-
-main
-rm -rf "$tmpdir"